'use strict';Object.defineProperty(exports, "__esModule", { value: true });var _chalk;














function _load_chalk() {return _chalk = _interopRequireDefault(require('chalk'));}var _stringLength;
function _load_stringLength() {return _stringLength = _interopRequireDefault(require('string-length'));}var _scroll_list;
function _load_scroll_list() {return _scroll_list = _interopRequireDefault(require('./lib/scroll_list'));}var _terminal_utils;
function _load_terminal_utils() {return _terminal_utils = require('./lib/terminal_utils');}var _highlight;
function _load_highlight() {return _highlight = _interopRequireDefault(require('./lib/highlight'));}var _utils;
function _load_utils() {return _utils = require('./reporters/utils');}var _Prompt;
function _load_Prompt() {return _Prompt = _interopRequireDefault(require('./lib/Prompt'));}var _pattern_mode_helpers;
function _load_pattern_mode_helpers() {return _pattern_mode_helpers = require('./lib/pattern_mode_helpers');}var _pattern_prompt;








function _load_pattern_prompt() {return _pattern_prompt = _interopRequireDefault(require('./pattern_prompt'));}function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}






class TestPathPatternPrompt extends (_pattern_prompt || _load_pattern_prompt()).default {


  constructor(pipe, prompt) {
    super(pipe, prompt);
    this._entityName = 'filenames';
  }

  _onChange(pattern, options) {
    super._onChange(pattern, options);
    this._printTypeahead(pattern, options);
  }

  _printTypeahead(pattern, options) {
    const matchedTests = this._getMatchedTests(pattern);
    const total = matchedTests.length;
    const pipe = this._pipe;
    const prompt = this._prompt;

    (0, (_pattern_mode_helpers || _load_pattern_mode_helpers()).printPatternCaret)(pattern, pipe);

    if (pattern) {
      (0, (_pattern_mode_helpers || _load_pattern_mode_helpers()).printPatternMatches)(total, 'file', pipe);

      const prefix = `  ${(_chalk || _load_chalk()).default.dim('\u203A')} `;
      const padding = (0, (_stringLength || _load_stringLength()).default)(prefix) + 2;
      const width = (0, (_terminal_utils || _load_terminal_utils()).getTerminalWidth)();var _scroll =
      (0, (_scroll_list || _load_scroll_list()).default)(total, options);const start = _scroll.start,end = _scroll.end,index = _scroll.index;

      prompt.setTypeaheadLength(total);

      matchedTests.
      slice(start, end).
      map((_ref) => {let path = _ref.path,context = _ref.context;
        const filePath = (0, (_utils || _load_utils()).trimAndFormatPath)(
        padding,
        context.config,
        path,
        width);

        return (0, (_highlight || _load_highlight()).default)(path, filePath, pattern, context.config.rootDir);
      }).
      map((item, i) => (0, (_pattern_mode_helpers || _load_pattern_mode_helpers()).formatTypeaheadSelection)(item, i, index, prompt)).
      forEach(item => (0, (_pattern_mode_helpers || _load_pattern_mode_helpers()).printTypeaheadItem)(item, pipe));

      if (total > end) {
        (0, (_pattern_mode_helpers || _load_pattern_mode_helpers()).printMore)('file', pipe, total - end);
      }
    } else {
      (0, (_pattern_mode_helpers || _load_pattern_mode_helpers()).printStartTyping)('filename', pipe);
    }

    (0, (_pattern_mode_helpers || _load_pattern_mode_helpers()).printRestoredPatternCaret)(pattern, this._currentUsageRows, pipe);
  }

  _getMatchedTests(pattern) {
    let regex;

    try {
      regex = new RegExp(pattern, 'i');
    } catch (e) {}

    let tests = [];
    if (regex) {
      this._searchSources.forEach((_ref2) => {let searchSource = _ref2.searchSource,context = _ref2.context;
        tests = tests.concat(searchSource.findMatchingTests(pattern).tests);
      });
    }

    return tests;
  }

  updateSearchSources(searchSources) {
    this._searchSources = searchSources;
  }}exports.default = TestPathPatternPrompt; /**
                                              * Copyright (c) 2014-present, Facebook, Inc. All rights reserved.
                                              *
                                              * This source code is licensed under the BSD-style license found in the
                                              * LICENSE file in the root directory of this source tree. An additional grant
                                              * of patent rights can be found in the PATENTS file in the same directory.
                                              *
                                              * 
                                              */